using Indotalent.ConfigBackEnd.Exceptions;
using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Thirdparty.VendorCategory.Cqrs;

public class UpdateVendorCategoryRequest
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public class UpdateVendorCategoryResponse
{
    public string? Id { get; set; }
    public bool Success { get; set; }
}

public record UpdateVendorCategoryCommand(UpdateVendorCategoryRequest Data) : IRequest<UpdateVendorCategoryResponse>;

public class UpdateVendorCategoryHandler : IRequestHandler<UpdateVendorCategoryCommand, UpdateVendorCategoryResponse>
{
    private readonly AppDbContext _context;

    public UpdateVendorCategoryHandler(AppDbContext context) => _context = context;

    public async Task<UpdateVendorCategoryResponse> Handle(UpdateVendorCategoryCommand request, CancellationToken cancellationToken)
    {
        var isExists = await _context.VendorCategory
            .AnyAsync(x => x.Name == request.Data.Name && x.Id != request.Data.Id, cancellationToken);

        if (isExists)
        {
            throw new AlreadyExistsException("Vendor Category", request.Data.Name ?? string.Empty);
        }

        var entity = await _context.VendorCategory
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null)
        {
            return new UpdateVendorCategoryResponse { Id = request.Data.Id, Success = false };
        }

        entity.Name = request.Data.Name;
        entity.Description = request.Data.Description;

        await _context.SaveChangesAsync(cancellationToken);

        return new UpdateVendorCategoryResponse
        {
            Id = entity.Id,
            Success = true
        };
    }
}